package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.SelfTakeUserService;
import com.gxwebsoft.shop.entity.SelfTakeUser;
import com.gxwebsoft.shop.param.SelfTakeUserParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 自提点人员控制器
 *
 * @author 科技小王子
 * @since 2025-12-03 14:22:38
 */
@Api(tags = "自提点人员管理")
@RestController
@RequestMapping("/api/shop/self-take-user")
public class SelfTakeUserController extends BaseController {
    @Resource
    private SelfTakeUserService selfTakeUserService;

    @ApiOperation("分页查询自提点人员")
    @GetMapping("/getByUser")
    public ApiResult<List<SelfTakeUser>> getByUser() {
        // 使用关联查询
        return success(selfTakeUserService.listRel(new SelfTakeUserParam(){{
            setUserId(getLoginUserId());
        }}));
    }

    @ApiOperation("分页查询自提点人员")
    @GetMapping("/page")
    public ApiResult<PageResult<SelfTakeUser>> page(SelfTakeUserParam param) {
        // 使用关联查询
        return success(selfTakeUserService.pageRel(param));
    }

    @ApiOperation("查询全部自提点人员")
    @GetMapping()
    public ApiResult<List<SelfTakeUser>> list(SelfTakeUserParam param) {
        // 使用关联查询
        return success(selfTakeUserService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:selfTakeUser:list')")
    @ApiOperation("根据id查询自提点人员")
    @GetMapping("/{id}")
    public ApiResult<SelfTakeUser> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(selfTakeUserService.getByIdRel(id));
    }

    @ApiOperation("添加自提点人员")
    @PostMapping()
    public ApiResult<?> save(@RequestBody SelfTakeUser selfTakeUser) {
        if (selfTakeUserService.save(selfTakeUser)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改自提点人员")
    @PutMapping()
    public ApiResult<?> update(@RequestBody SelfTakeUser selfTakeUser) {
        if (selfTakeUserService.updateById(selfTakeUser)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除自提点人员")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (selfTakeUserService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加自提点人员")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<SelfTakeUser> list) {
        if (selfTakeUserService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改自提点人员")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<SelfTakeUser> batchParam) {
        if (batchParam.update(selfTakeUserService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除自提点人员")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (selfTakeUserService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
